import java.io.*;
import java.awt.*;
import javax.swing.*;
import java.util.*;
import java.awt.event.*;
import olif.*;
import oapi.*;
import javax.swing.*;
import support.spellcheck.*;

/**
 * Title:        GUI
 * Description:
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author Alexander Culum
 * @version 1.0
 */

public class OAPIGUI extends JFrame {

	JButton convertXMLButton = new JButton();
	JButton convertCSVButton = new JButton();
	JButton spellcheckButton = new JButton();
	JButton enhanceButton = new JButton();
	JButton validationButton = new JButton();
	JButton lookupButton = new JButton();
	JLabel convertXMLLabel = new JLabel();
	JLabel convertCSVLabel = new JLabel();
	JLabel spellcheckLabel = new JLabel();
	JLabel enhanceLabel = new JLabel();
	JLabel validationLabel = new JLabel();
	JLabel lookupLabel = new JLabel();
	JTextField enhanceTextField = new JTextField();
	JTextField lookupTextField = new JTextField();
	Color fontColor = new Color(0, 0, 0);

	public OAPIGUI() {
		try {
			fInit();
		}
		catch(Exception e) {
			e.printStackTrace();
		}
	}
  
  	public static void main(String[] args) {
		OAPIGUI OAPIGUI = new OAPIGUI();
    	OAPIGUI.setTitle("OAPI GUI");
		OAPIGUI.setSize(440, 290);
		OAPIGUI.show();
	}
	
	private void fInit() throws Exception {
		getContentPane().setLayout(null);
		convertXMLButton.setBounds(new Rectangle(18, 25, 117, 27));
    	convertXMLButton.addActionListener(new OAPIGUI_convertXMLButton_actionAdapter(this));
    	convertXMLButton.setText("XML convert");
    	convertXMLButton.setFocusPainted(false);
		convertCSVButton.setBounds(new Rectangle(18, 60, 118, 27));
		convertCSVButton.addActionListener(new OAPIGUI_convertCSVButton_actionAdapter(this));
		convertCSVButton.setText("CSV convert");
    	convertCSVButton.setFocusPainted(false);
		spellcheckButton.setBounds(new Rectangle(18, 95, 118, 27));
		spellcheckButton.addActionListener(new OAPIGUI_spellcheckButton_actionAdapter(this));
		spellcheckButton.setText("spellcheck");
		spellcheckButton.setFocusPainted(false);
		enhanceButton.setBounds(new Rectangle(18, 130, 119, 27));
		enhanceButton.addActionListener(new OAPIGUI_enhanceButton_actionAdapter(this));
		enhanceButton.setText("enhance");
		enhanceButton.setFocusPainted(false);
		validationButton.setBounds(new Rectangle(18, 165, 120, 27));
		validationButton.addActionListener(new OAPIGUI_validationButton_actionAdapter(this));
		validationButton.setText("validate");
		validationButton.setFocusPainted(false);
		lookupButton.setBounds(new Rectangle(18, 200, 120, 27));
		lookupButton.addActionListener(new OAPIGUI_lookupButton_actionAdapter(this));
		lookupButton.setText("lookup");
		lookupButton.setFocusPainted(false);
		convertXMLLabel.setFont(new java.awt.Font("Monospaced", 1, 12));
		convertXMLLabel.setBounds(new Rectangle(164, 30, 164, 17));
		convertXMLLabel.setText("convert XML To OLIF");
		convertXMLLabel.setForeground(fontColor);
		convertCSVLabel.setFont(new java.awt.Font("Monospaced", 1, 12));
		convertCSVLabel.setBounds(new Rectangle(164, 65, 164, 17));
		convertCSVLabel.setText("convert CSV To OLIF");
		convertCSVLabel.setForeground(fontColor);
		spellcheckLabel.setFont(new java.awt.Font("Monospaced", 1, 12));
		spellcheckLabel.setBounds(new Rectangle(164, 100, 264, 17));
		spellcheckLabel.setText("spellcheck canonical form (only en)");
		spellcheckLabel.setForeground(fontColor);
		enhanceLabel.setFont(new java.awt.Font("Monospaced", 1, 12));
		enhanceLabel.setBounds(new Rectangle(164, 135, 164, 17));
		enhanceLabel.setText("enhance element");
		enhanceLabel.setForeground(fontColor);
		validationLabel.setFont(new java.awt.Font("Monospaced", 1, 12));
		validationLabel.setBounds(new Rectangle(163, 170, 264, 17));
		validationLabel.setText("validate current OLIF file");
		validationLabel.setForeground(fontColor);
		lookupLabel.setFont(new java.awt.Font("Monospaced", 1, 12));
		lookupLabel.setBounds(new Rectangle(163, 205, 164, 17));
		lookupLabel.setText("lookup");
		lookupLabel.setForeground(fontColor);
		enhanceTextField.setText("/entry/mono/keyDC/semReading");
		enhanceTextField.setBounds(new Rectangle(300, 130, 105, 26));
		lookupTextField.setText("book");
		lookupTextField.setBounds(new Rectangle(300, 200, 105, 26));
		this.getContentPane().add(convertXMLButton, null);
		this.getContentPane().add(convertCSVButton, null);
		this.getContentPane().add(spellcheckButton, null);
		this.getContentPane().add(enhanceButton, null);
		this.getContentPane().add(validationButton, null);
		this.getContentPane().add(lookupButton, null);
		this.getContentPane().add(convertXMLLabel, null);
		this.getContentPane().add(convertCSVLabel, null);
		this.getContentPane().add(spellcheckLabel, null);
		this.getContentPane().add(enhanceLabel, null);
		this.getContentPane().add(validationLabel, null);
		this.getContentPane().add(lookupLabel, null);
		this.getContentPane().add(enhanceTextField, null);
		this.getContentPane().add(lookupTextField, null);
	}

	void convertXMLButton_actionPerformed(ActionEvent e) {
		if (OAPICLI.convertXMLToOlif()) {
			JOptionPane.showConfirmDialog(this, "XML conversion successful", "OAPI", JOptionPane.DEFAULT_OPTION, JOptionPane.INFORMATION_MESSAGE);
		} else {
			JOptionPane.showConfirmDialog(this, "XML conversion failure", "OAPI", JOptionPane.DEFAULT_OPTION, JOptionPane.ERROR_MESSAGE);
		}
	}

	void convertCSVButton_actionPerformed(ActionEvent e) {
		if (OAPICLI.convertCSVToOlif()) {
			JOptionPane.showConfirmDialog(this, "CSV conversion successful", "OAPI", JOptionPane.DEFAULT_OPTION, JOptionPane.INFORMATION_MESSAGE);
		} else {
			JOptionPane.showConfirmDialog(this, "CSV conversion failure", "OAPI", JOptionPane.DEFAULT_OPTION, JOptionPane.ERROR_MESSAGE);
		}
	}

	void spellcheckButton_actionPerformed(ActionEvent e) {
		if (OAPICLI.spellcheck()) {
			JOptionPane.showConfirmDialog(this, "spellcheck successfully completed", "OAPI", JOptionPane.DEFAULT_OPTION, JOptionPane.INFORMATION_MESSAGE);
		} else {
			JOptionPane.showConfirmDialog(this, "spellcheck failure", "OAPI", JOptionPane.DEFAULT_OPTION, JOptionPane.ERROR_MESSAGE);
		}
	}

	void enhanceButton_actionPerformed(ActionEvent e) {
		if (OAPICLI.enhance(enhanceTextField.getText())) {
			JOptionPane.showConfirmDialog(this, "element successfully enhanced", "OAPI", JOptionPane.DEFAULT_OPTION, JOptionPane.INFORMATION_MESSAGE);
		} else {
			JOptionPane.showConfirmDialog(this, "enhancing failure", "OAPI", JOptionPane.DEFAULT_OPTION, JOptionPane.ERROR_MESSAGE);
		}
	}

	void validationButton_actionPerformed(ActionEvent e) {
		if (OAPICLI.validate()) {
			JOptionPane.showConfirmDialog(this, "file is valid", "OAPI", JOptionPane.DEFAULT_OPTION, JOptionPane.INFORMATION_MESSAGE);
		} else {
			JOptionPane.showConfirmDialog(this, "file is not valid", "OAPI", JOptionPane.DEFAULT_OPTION, JOptionPane.ERROR_MESSAGE);
		}
	}

	void lookupButton_actionPerformed(ActionEvent e) {
		if (OAPICLI.lookup(lookupTextField.getText())) {
			JOptionPane.showConfirmDialog(this, "lookup successfully finished", "OAPI", JOptionPane.DEFAULT_OPTION, JOptionPane.INFORMATION_MESSAGE);
		} else {
			JOptionPane.showConfirmDialog(this, "lookup failure", "OAPI", JOptionPane.DEFAULT_OPTION, JOptionPane.ERROR_MESSAGE);
		}
	}

	protected void processWindowEvent(WindowEvent e) {
		super.processWindowEvent(e);
		if (e.getID() == WindowEvent.WINDOW_CLOSING) {
			System.exit(0);
		}
	}

}

class OAPIGUI_convertXMLButton_actionAdapter implements java.awt.event.ActionListener {
	OAPIGUI adaptee;

	OAPIGUI_convertXMLButton_actionAdapter(OAPIGUI adaptee) {
		this.adaptee = adaptee;
	}
	public void actionPerformed(ActionEvent e) {
		adaptee.convertXMLButton_actionPerformed(e);
	}
}

class OAPIGUI_convertCSVButton_actionAdapter implements java.awt.event.ActionListener {
	OAPIGUI adaptee;

	OAPIGUI_convertCSVButton_actionAdapter(OAPIGUI adaptee) {
		this.adaptee = adaptee;
	}
	public void actionPerformed(ActionEvent e) {
		adaptee.convertCSVButton_actionPerformed(e);
	}
}

class OAPIGUI_spellcheckButton_actionAdapter implements java.awt.event.ActionListener {
	OAPIGUI adaptee;

	OAPIGUI_spellcheckButton_actionAdapter(OAPIGUI adaptee) {
		this.adaptee = adaptee;
	}
	public void actionPerformed(ActionEvent e) {
		adaptee.spellcheckButton_actionPerformed(e);
	}
}

class OAPIGUI_enhanceButton_actionAdapter implements java.awt.event.ActionListener {
	OAPIGUI adaptee;

	OAPIGUI_enhanceButton_actionAdapter(OAPIGUI adaptee) {
		this.adaptee = adaptee;
	}
	public void actionPerformed(ActionEvent e) {
		adaptee.enhanceButton_actionPerformed(e);
	}
}

class OAPIGUI_validationButton_actionAdapter implements java.awt.event.ActionListener {
	OAPIGUI adaptee;

	OAPIGUI_validationButton_actionAdapter(OAPIGUI adaptee) {
		this.adaptee = adaptee;
	}
	public void actionPerformed(ActionEvent e) {
		adaptee.validationButton_actionPerformed(e);
	}
}

class OAPIGUI_lookupButton_actionAdapter implements java.awt.event.ActionListener {
	OAPIGUI adaptee;

	OAPIGUI_lookupButton_actionAdapter(OAPIGUI adaptee) {
		this.adaptee = adaptee;
	}
	public void actionPerformed(ActionEvent e) {
		adaptee.lookupButton_actionPerformed(e);
	}
}
