package support.spellcheck;
/* This class is based on Lawrence Phillips original c++ code for this class.
   Found here: http://aspell.sourceforge.net/metaphone/


*/
import java.io.Serializable;

class DoubleMeta implements Serializable {

    private StringBuffer primary;
    private StringBuffer secondary;
    private boolean alternate;
    private String in;
    private int length;
    private int last;

    private boolean SlavoGermanic() {
        if ((in.indexOf("W") > -1) || (in.indexOf("K") > -1) || (in.indexOf("CZ") > -1) || (in.indexOf("WITZ") > -1))
            return true;
        return false;
    }

    private void MetaphAdd(String main) {
        if (main != null) {
            primary.append(main);
            secondary.append(main);
        }
    }

    private void MetaphAdd(String main, String alt) {
        if (main != null)
            primary.append(main);
        if (alt != null) {
            alternate = true;
            if (alt.charAt(0) != ' ')
                secondary.append(alt);
        } else {
            if ((main != null) && (main.charAt(0) != ' '))
                secondary.append(main);
        }
    }

    private boolean isVowel(int at) {
        if ((at < 0) || (at >= length))
            return false;

        char it = in.charAt(at);
        if ((it == 'A') || (it == 'E') || (it == 'I') || (it == 'O') || (it == 'U') || (it == 'Y'))
            return true;

        return false;
    }

    private boolean stringAt(String string, int start, int length, String[] list) {
        if ((start < 0) || (start >= string.length()))
            return false;
        for (int i = 0; i < list.length; i++) {
            if (list[i].equals(string.substring(start, start + length)))
                return true;
        }
        return false;
    }

    public String process(String word) {
        primary = new StringBuffer();
        secondary = new StringBuffer();
        in = word + "     ";
        int current = 0;
        length = in.length();
        if (length < 1)
            return "";
        last = length - 1;
        alternate = false;
        in = in.toUpperCase();
        String[] myList = {"GN","KN","PN","WR","PS",""};
        if (stringAt(in, 0, 2, myList))
            current += 1;

        if (in.charAt(0) == 'X') {
            MetaphAdd("S");
            current += 1;
        }
        while (true) {
            if (current >= length)
                break;
            switch (in.charAt(current)) {
                case 'A':
                case 'E':
                case 'I':
                case 'O':
                case 'U':
                case 'Y':
                    if (current == 0)
                        MetaphAdd("A");
                    current += 1;
                    break;
                case 'B':
                    MetaphAdd("P");
                    if (in.charAt(current + 1) == 'B')
                        current += 2;
                    else
                        current += 1;
                    break;
                case '':
                    MetaphAdd("S");
                    current += 1;
                    break;
                case 'C':
                    String[] list1 = {"ACH",""};
                    String[] list2 = {"BACHER","MACHER",""};
                    if ((current > 1) && !isVowel(current - 2)
                            && stringAt(in, (current - 1), 3, list1)
                            && (in.charAt(current + 2) != 'I')
                            && (in.charAt(current + 2) != 'E')
                            || stringAt(in, (current - 2), 6, list2)) {
                        MetaphAdd("K");
                        current += 2;
                        break;
                    }
                    String[] list3 = {"CAESAR",""};
                    if ((current == 0) && stringAt(in, current, 6, list3)) {
                        MetaphAdd("S");
                        current += 2;
                        break;
                    }
                    String[] list4 = {"CHIA",""};
                    if (stringAt(in, current, 4, list4)) {
                        MetaphAdd("K");
                        current += 2;
                        break;
                    }
                    String[] list5 = {"CH",""};
                    if (stringAt(in, current, 2, list5)) {
                        String[] list6 = {"CHAE",""};
                        if ((current > 0) && stringAt(in, current, 4, list6)) {
                            MetaphAdd("K", "X");
                            current += 2;
                            break;
                        }
                        String[] list7 = {"HARAC","HARIS",""};
                        String[] list8 = {"HOR", "HYM", "HIA", "HEM", ""};
                        String[] list9 = {"CHORE",""};
                        if ((current == 0) && stringAt(in, (current + 1), 5, list7)
                                || stringAt(in, current + 1, 3, list8)
                                && !stringAt(in, 0, 5, list9)) {
                            MetaphAdd("K");
                            current += 2;
                            break;
                        }
                        String[] list10 = {"VAN ","VON ",""};
                        String[] list11 = {"SCH",""};
                        String[] list12 = {"ORCHES", "ARCHIT", "ORCHID", ""};
                        String[] list13 = {"T", "S", ""};
                        String[] list14 = {"A", "O", "U", "E", ""};
                        String[] list15 = {"L", "R", "N", "M", "B", "H", "F", "V", "W", " ", ""};
                        if (stringAt(in, 0, 4, list10) || stringAt(in, 0, 3, list11)
                                || stringAt(in, current - 2, 6, list12)
                                || stringAt(in, current + 2, 1, list13)
                                || (stringAt(in, current - 1, 1, list14) || (current == 0))
                                && stringAt(in, current + 2, 1, list15)) {
                            MetaphAdd("K");
                        } else {
                            String[] list16 = {"MC",""};
                            if (current > 0) {
                                if (stringAt(in, 0, 2, list16))
                                    MetaphAdd("K");
                                else
                                    MetaphAdd("X", "K");
                            } else {
                                MetaphAdd("X");
                            }
                        }
                        current += 2;
                        break;
                    }
                    String[] list17 = {"CZ",""};
                    String[] list18 = {"WICZ",""};
                    if (stringAt(in, current, 2, list17) && !stringAt(in, current, 4, list18)) {
                        MetaphAdd("S", "X");
                        current += 2;
                        break;
                    }
                    String[] list19 = {"CIA",""};
                    if (stringAt(in, current, 2, list19)) {
                        MetaphAdd("X");
                        current += 2;
                        break;
                    }
                    String[] list20 = {"CC",""};
                    String[] list21 = {"I", "E", "H", ""};
                    String[] list22 = {"HU", ""};
                    String[] list23 = {"UCCEE", "UCCES", ""};
                    if (stringAt(in, current, 2, list20) && !((current == 1) && in.charAt(0) == 'M')) {
                        if (stringAt(in, current + 2, 1, list21) && !stringAt(in, current + 2, 2, list22)) {

                            if (((current == 1) && (in.charAt(current - 1) == 'A'))
                                    || stringAt(in, (current - 1), 5, list23))
                                MetaphAdd("KS");
                            else
                                MetaphAdd("X");
                            current += 3;
                            break;
                        } else {
                            MetaphAdd("K");
                            current += 2;
                            break;
                        }
                    }
                    String[] list24 = { "CK", "CG", "CQ", ""};
                    if (stringAt(in, current, 2, list24)) {
                        MetaphAdd("K");
                        current += 2;
                        break;
                    }
                    String[] list25 = { "CI", "CE", "CY", ""};
                    String[] list26 = { "CIO", "CIE", "CIA", ""};
                    if (stringAt(in, current, 2, list25)) {
                        if (stringAt(in, current, 3, list26))
                            MetaphAdd("S", "X");
                        else
                            MetaphAdd("S");
                        current += 2;
                        break;
                    }

                    MetaphAdd("K");

                    String[] list27 = { " C", " Q", " G", ""};
                    String[] list28 = { "C", "K", "Q", "" };
                    String[] list29 = { "CE", "CI", ""};

                    if (stringAt(in, current + 1, 2, list27))
                        current += 3;
                    else if (stringAt(in, current + 1, 1, list28)
                            && !stringAt(in, current + 1, 2, list29))
                        current += 2;
                    else
                        current += 1;
                    break;

                case 'D':
                    String[] list30 = {"DG",""};
                    String[] list31 = {"I","E","Y",""};
                    if (stringAt(in, current, 2, list30))
                        if (stringAt(in, current + 2, 1, list31)) {
                            MetaphAdd("J");
                            current += 3;
                            break;
                        } else {
                            MetaphAdd("TK");
                            current += 2;
                            break;
                        }
                    String[] list32 = {"DT","DD",""};
                    if (stringAt(in, current, 2, list32)) {
                        MetaphAdd("T");
                        current += 2;
                        break;
                    }
                    MetaphAdd("T");
                    current += 1;
                    break;
                case 'F':
                    if (in.charAt(current + 1) == 'F')
                        current += 2;
                    else
                        current += 1;
                    MetaphAdd("F");
                    break;
                case 'G':
                    if (in.charAt(current + 1) == 'H') {
                        if ((current > 0) && !isVowel(current - 1)) {
                            MetaphAdd("K");
                            current += 2;
                            break;
                        }
                        if (current < 3) {
                            if (current == 0) {
                                if (in.charAt(current + 2) == 'I')
                                    MetaphAdd("J");
                                else
                                    MetaphAdd("K");
                                current += 2;
                                break;
                            }
                        }
                        String[] list33 = { "B", "H", "D", "" };
                        String[] list34 = { "B", "H", "D", "" };
                        String[] list35 = { "B", "H", ""};
                        String[] list36 = { "C", "G", "L", "R", "T", "" };
                        if ((current > 1) && stringAt(in, current - 2, 1, list33)
                                || ((current > 2) && stringAt(in, current - 3, 1, list34))
                                || ((current > 3) && stringAt(in, current - 4, 1, list35))) {
                            current += 2;
                            break;
                        } else {
                            if ((current > 2) && (in.charAt(current - 1) == 'U')
                                    && stringAt(in, current - 3, 1, list36)) {
                                MetaphAdd("F");
                            } else {
                                if ((current > 0) && (in.charAt(current - 1) != 'I'))
                                    MetaphAdd("K");
                            }
                            current += 2;
                            break;
                        }
                    }
                    String[] list37 = { "EY", "" };
                    if (in.charAt(current + 1) == 'N') {
                        if ((current == 1) && isVowel(0) && !SlavoGermanic()) {
                            MetaphAdd("KN", "N");
                        } else {
                            if (!stringAt(in, current + 2, 2, list37) && (in.charAt(current + 1) != 'Y')
                                    && !SlavoGermanic()) {
                                MetaphAdd("N", "KN");
                            } else {
                                MetaphAdd("KN");
                            }
                        }
                        current += 2;
                        break;
                    }
                    String[] list38 = { "LI", "" };
                    if (stringAt(in, current + 1, 2, list38) && !SlavoGermanic()) {
                        MetaphAdd("KL", "L");
                        current += 2;
                        break;
                    }
                    String[] list39 = { "ES", "EP", "EB", "EL", "EY", "IB", "IL", "IN", "IE", "EI", "ER", ""};
                    if ((current == 0) && ((in.charAt(current + 1) == 'Y') || stringAt(in, current + 1, 2, list39))) {
                        MetaphAdd("K", "J");
                        current += 2;
                        break;
                    }
                    String[] list40 = { "ER", "" };
                    String[] list41 = { "DANGER", "RANGER", "MANGER", ""};
                    String[] list42 = { "E", "I", "" };
                    String[] list43 = { "RGY", "OGY", "" };
                    if ((stringAt(in, current + 1, 2, list40) || (in.charAt(current + 1) == 'Y'))
                            && !stringAt(in, 0, 6, list41) && !stringAt(in, current - 1, 1, list42)
                            && !stringAt(in, current - 1, 3, list43)) {
                        MetaphAdd("K", "J");
                        current += 2;
                        break;
                    }

                    String[] list44 = { "E", "I", "Y", "" };
                    String[] list45 = { "AGGI", "OGGI", ""};
                    String[] list46 = { "VAN ", "VON ", "" };
                    String[] list47 = { "SCH", ""};
                    String[] list48 = { "ET", ""};
                    String[] list49 = { "IER ", ""};
                    if (stringAt(in, current + 1, 1, list44) || stringAt(in, current - 1, 4, list45)) {
                        if (stringAt(in, 0, 4, list46) || stringAt(in, 0, 3, list47) || stringAt(in, current + 1, 2, list48)) {
                            MetaphAdd("K");
                        } else {
                            if (stringAt(in, current + 1, 4, list49))
                                MetaphAdd("J");
                            else
                                MetaphAdd("J", "K");
                        }
                        current += 2;
                        break;
                    }
                    if (in.charAt(current + 1) == 'G')
                        current += 2;
                    else
                        current += 1;
                    MetaphAdd("K");
                    break;
                case 'H':
                    if (((current == 0) || isVowel(current - 1)) && isVowel(current + 1)) {
                        MetaphAdd("H");
                        current += 2;
                    } else {
                        current += 1;
                    }
                    break;
                case 'J':
                    String[] list50 = { "JOSE", "" };
                    String[] list51 = { "SAN ", "" };
                    String[] list52 = { "SAN ", "" };
                    if (stringAt(in, current, 4, list50) || stringAt(in, 0, 4, list51)) {
                        if ((current == 0) && (in.charAt(current + 4) == ' ') || stringAt(in, 0, 4, list52)) {
                            MetaphAdd("H");
                        } else {
                            MetaphAdd("J");
                        }
                        current += 1;
                        break;
                    }
                    String[] list53 = { "JOSE", ""};
                    String[] list54 = { "L", "T", "K", "S", "N", "M", "B", "Z", "" };
                    String[] list55 = { "S", "K", "L", ""};
                    if ((current == 0) && !stringAt(in, current, 4, list53)) {
                        MetaphAdd("J", "A");
                    } else {
                        if (isVowel(current - 1) && !SlavoGermanic() && ((in.charAt(current + 1) == 'A') || in.charAt(current + 1) == 'O')) {
                            MetaphAdd("J", "H");
                        } else {
                            if (current == last) {
                                MetaphAdd("J", " ");
                            } else {
                                if (!stringAt(in, current + 1, 1, list54) && !stringAt(in, current - 1, 1, list55)) {
                                    MetaphAdd("J");
                                }
                            }
                        }
                    }
                    if (in.charAt(current + 1) == 'J')
                        current += 2;
                    else
                        current += 1;
                    break;
                case 'K':
                    if (in.charAt(current + 1) == 'K')
                        current += 2;
                    else
                        current += 1;
                    MetaphAdd("K");
                    break;
                case 'L':
                    String[] list56 = { "ILLO", "ILLA", "ALLE", ""};
                    String[] list57 = { "AS", "OS", ""};
                    String[] list58 = { "A", "O", ""};
                    String[] list59 = { "ALLE", ""};
                    if (in.charAt(current + 1) == 'L') {
                        if (((current == (length - 3)) &&
                                stringAt(in, current - 1, 4, list56))
                                || ((stringAt(in, last - 1, 2, list57) || stringAt(in, last, 1, list58))
                                && stringAt(in, current - 1, 4, list59))) {
                            MetaphAdd("L", " ");
                            current += 2;
                            break;
                        }
                        current += 2;
                    } else
                        current += 1;
                    MetaphAdd("L");
                    break;
                case 'M':
                    String[] list60 = { "UMB", ""};
                    String[] list61 = { "ER", ""};
                    if ((stringAt(in, current - 1, 3, list60)
                            && (((current + 1) == last) || stringAt(in, current + 2, 2, list61))) || (in.charAt(current + 1) == 'M'))
                        current += 2;
                    else
                        current += 1;
                    MetaphAdd("M");
                    break;
                case 'N':
                    if (in.charAt(current + 1) == 'N')
                        current += 2;
                    else
                        current += 1;
                    MetaphAdd("N");
                    break;
                case '':
                    current += 1;
                    MetaphAdd("N");
                    break;
                case 'P':
                    String[] list62 = { "P", "B", ""};
                    if (in.charAt(current + 1) == 'N') {
                        MetaphAdd("F");
                        current += 2;
                        break;
                    }
                    if (stringAt(in, current + 1, 1, list62))
                        current += 2;
                    else
                        current += 1;
                    MetaphAdd("P");
                    break;
                case 'Q':
                    if (in.charAt(current + 1) == 'Q')
                        current += 2;
                    else
                        current += 1;
                    MetaphAdd("K");
                    break;
                case 'R':
                    String[] list63 = {"IE", "" };
                    String[] list64 = { "ME", "MA", ""};
                    if ((current == last) && !SlavoGermanic() &&
                            stringAt(in, current - 2, 2, list63) &&
                            !stringAt(in, current - 4, 2, list64))
                        MetaphAdd("", "R");
                    else
                        MetaphAdd("R");
                    if (in.charAt(current + 1) == 'R')
                        current += 2;
                    else
                        current += 1;
                    break;
                case 'S':
                    String[] list65 = { "ISL", "YSL", ""};
                    if (stringAt(in, current - 1, 3, list65)) {
                        current += 1;
                        break;
                    }
                    String[] list66 = { "SUGAR", ""};
                    if ((current == 0) && stringAt(in, current, 5, list66)) {
                        MetaphAdd("X", "S");
                        current += 1;
                        break;
                    }
                    String[] list67 = { "SH", ""};
                    String[] list68 = { "HEIM", "HOEK", "HOLM", "HOLZ", ""};
                    if (stringAt(in, current, 2, list67)) {
                        if (stringAt(in, current + 1, 4, list68))
                            MetaphAdd("S");
                        else
                            MetaphAdd("X");
                        current += 2;
                        break;
                    }
                    String[] list69 = { "SIO", "SIA", ""};
                    String[] list70 = { "SIAN", ""};
                    if (stringAt(in, current, 3, list69) || stringAt(in, current, 4, list70)) {
                        if (!SlavoGermanic())
                            MetaphAdd("S", "X");
                        else
                            MetaphAdd("S");
                        current += 3;
                        break;
                    }
                    String[] list71 = { "M", "N", "L", "W", ""};
                    String[] list72 = { "Z", ""};
                    String[] list73 = { "Z", ""};
                    if (((current == 0)
                            && stringAt(in, current + 1, 1, list71)) || stringAt(in, current + 1, 1, list72)) {
                        MetaphAdd("S", "X");
                        if (stringAt(in, current + 1, 1, list73))
                            current += 2;
                        else
                            current += 1;
                        break;
                    }
                    String[] list74 = { "SC", ""};
                    String[] list75 = { "OO", "ER", "EN", "UY", "ED", "EM", ""};
                    String[] list76 = { "ER", "EN", ""};
                    String[] list77 = { "I", "E", "Y", ""};
                    if (stringAt(in, current, 2, list74)) {
                        if (in.charAt(current + 2) == 'H')
                            if (stringAt(in, current + 3, 2, list75)) {
                                if (stringAt(in, current + 3, 2, list76)) {
                                    MetaphAdd("X", "SK");
                                } else {
                                    MetaphAdd("SK");
                                }
                                current += 3;
                                break;
                            } else {
                                if ((current == 0) && !isVowel(3) && (in.charAt(3) != 'W'))
                                    MetaphAdd("X", "S");
                                else
                                    MetaphAdd("X");
                                current += 3;
                                break;
                            }

                        if (stringAt(in, current + 2, 1, list77)) {
                            MetaphAdd("S");
                            current += 3;
                            break;
                        }
                        MetaphAdd("SK");
                        current += 3;
                        break;
                    }
                    String[] list78 = { "AI", "OI", ""};
                    if ((current == last) && stringAt(in, current - 2, 2, list78))
                        MetaphAdd("", "S");
                    else
                        MetaphAdd("S");
                    String[] list79 = {  "S", "Z", ""};
                    if (stringAt(in, current + 1, 1, list79))
                        current += 2;
                    else
                        current += 1;
                    break;
                case 'T':
                    String[] list80 = { "TION", ""};
                    if (stringAt(in, current, 4, list80)) {
                        MetaphAdd("X");
                        current += 3;
                        break;
                    }
                    String[] list81 = { "TIA", "TCH", ""};
                    if (stringAt(in, current, 3, list81)) {
                        MetaphAdd("X");
                        current += 3;
                        break;
                    }
                    String[] list82 = { "TH", ""};
                    String[] list83 = { "TTH", ""};
                    String[] list84 = { "OM", "AM", ""};
                    String[] list85 = { "VAN ", "VON ", ""};
                    String[] list86 = { "SCH", ""};
                    if (stringAt(in, current, 2, list82) || stringAt(in, current, 3, list83)) {
                        if (stringAt(in, (current + 2), 2, list84)
                                || stringAt(in, 0, 4, list85)
                                || stringAt(in, 0, 3, list86)) {
                            MetaphAdd("T");
                        } else {
                            MetaphAdd("0", "T");
                        }
                        current += 2;
                        break;
                    }
                    String[] list87 = { "T", "D", ""};
                    if (stringAt(in, current + 1, 1, list87)) {
                        current += 2;
                    } else
                        current += 1;
                    MetaphAdd("T");
                    break;
                case 'V':
                    if (in.charAt(current + 1) == 'V')
                        current += 2;
                    else
                        current += 1;
                    MetaphAdd("F");
                    break;
                case 'W':
                    String[] list88 = { "WR", ""};
                    if (stringAt(in, current, 2, list88)) {
                        MetaphAdd("R");
                        current += 2;
                        break;
                    }
                    String[] list89 = { "WH", ""};
                    if ((current == 0) && (isVowel(current + 1) || stringAt(in, current, 2, list89))) {
                        if (isVowel(current + 1))
                            MetaphAdd("A", "F");
                        else
                            MetaphAdd("A");
                    }
                    String[] list90 = { "EWSKI", "EWSKY", "OWSKI", "OWSKY", ""};
                    String[] list91 = { "SCH", ""};
                    if (((current == last) && isVowel(current - 1)) || stringAt(in, current - 1, 5, list90) || stringAt(in, 0, 3, list91)) {
                        MetaphAdd("F");
                        current += 1;
                        break;
                    }
                    String[] list92 = { "WICZ", "WITZ", ""};
                    if (stringAt(in, current, 4, list92)) {
                        MetaphAdd("TS", "FX");
                        current += 4;
                        break;
                    }
                    current += 1;
                    break;
                case 'X':
                    String[] list93 = { "IAU", "EAU", ""};
                    String[] list94 = { "AU", "OU", ""};
                    String[] list95 = { "C", "X", ""};
                    if (!((current == last) && (stringAt(in, current - 3, 3, list93)
                            || stringAt(in, current - 2, 2, list94))))
                        MetaphAdd("KS");
                    if (stringAt(in, current + 1, 1, list95))
                        current += 2;
                    else
                        current += 1;
                    break;
                case 'Z':
                    String[] list96 = { "ZO", "ZI", "ZA", ""};
                    if (in.charAt(current + 1) == 'H') {
                        MetaphAdd("J");
                        current += 2;
                        break;
                    } else if (stringAt(in, (current + 1), 2, list96) ||
                            (SlavoGermanic() && ((current > 0) && in.charAt(current - 1) != 'T'))) {
                        MetaphAdd("S", "TS");
                    } else {
                        MetaphAdd("S");
                    }
                    if (in.charAt(current + 1) == 'Z')
                        current += 2;
                    else
                        current += 1;
                    break;
                default:
                    current += 1;
            }
        }
        return primary.toString();
    }
}
