package support.spellcheck;

import java.io.BufferedReader;
import java.io.InputStreamReader;

public class EditDistance {

    private int[][] matrix;

    public int getDistance(String a, String b, EditDistanceWeights w) {
        int a_size = a.length() + 1;
        int b_size = b.length() + 1;
        matrix = new int[a_size][b_size];
        matrix[0][0] = 0;
        for (int j = 1; j != b_size; ++j)
            matrix[0][j] = matrix[0][j - 1] + w.del1;
        a = " " + a;
        b = " " + b;
        int te;
        for (int i = 1; i != a_size; ++i) {
            matrix[i][0] = matrix[i - 1][0] + w.del2;
            for (int j = 1; j != b_size; ++j) {
                if (a.charAt(i) == b.charAt(j)) {
                    matrix[i][j] = matrix[i - 1][j - 1];
                } else {
                    matrix[i][j] = w.sub + matrix[i - 1][j - 1];
                    if (i != 1 && j != 1 &&
                            a.charAt(i) == b.charAt(j - 1) && a.charAt(i - 1) == b.charAt(j)) {
                        te = w.swap + matrix[i - 2][j - 2];
                        if (te < matrix[i][j]) matrix[i][j] = te;
                    }
                    te = w.del1 + matrix[i - 1][j];
                    if (te < matrix[i][j]) matrix[i][j] = te;
                    te = w.del2 + matrix[i][j - 1];
                    if (te < matrix[i][j]) matrix[i][j] = te;
                }
            }
        }
        return matrix[a_size - 1][b_size - 1];
    }

    public static void main(String[] args) throws Exception {
        EditDistance ed = new EditDistance();
        BufferedReader stdin = new BufferedReader(new InputStreamReader(System.in));
        String input = "";
        String input2 = "";
        while (input != null) {
            input = stdin.readLine();
            input2 = stdin.readLine();
            System.out.println(ed.getDistance(input, input2, new EditDistanceWeights()));
        }
    }
}


