package support.uuid;

import java.rmi.dgc.VMID;

/**
* The UUID class provides a "Universal Unique Identifier", which is used when new entries are created.
* 
* UUID is a wrapper for java.rmi.gdc.VMID, which returns a "Virtual Maschine Identifier".
* This identifer is globally unique under following cirsumstances:
*
* For a UID, the following requirements have to be met:
* a) the machine takes more than one second to reboot, and <br>
* b) the machine's clock is never set backward
*
* For a UUID, a UID combined which a unique IP address, the following conditions have to be met:
* a) the conditions for uniqueness for objects of the class java.rmi.server.UID are satisfied, and <br>
* b) an address can be obtained for this host that is unique and constant for the lifetime of this object.
*
*/
public class UUID {
	
	VMID vmid;
	
/**
* <p> This creates a new UUID object. </p>
*
*/
	public UUID() {
		vmid = new VMID();
	}
	
/**
* <p> This returns the UUID object in an ISO-11578 compatible format. </p>
*
*/
	public String toString() {
		return vmid.toString();
	}
}

	
